<template>
  <div class="contents">
    <div class="contents_wrap">
      <div class="top_wrap">
        <h3 class="title">유치채널현황</h3>
        <p class="breadcrumb">유치현황관리 &gt; 유치채널현황</p>
      </div>
      <div class="search_wrap">
        <div class="group">
          <div class="input_box cal">
            <label for="right" class="label">조회기간</label>
            <div class="term">
              <span class="custom_input icon_date">
                <vuejs-datepicker
                  :language="ko"
                  :format="customFormatter"
                  :disabled-dates="disabledSDate"
                  v-model="startDate"
                  @selected="selectedStartDate(0)"
                  @closed="closeDate('start')"
                ></vuejs-datepicker> </span
              >~
              <span class="custom_input icon_date">
                <vuejs-datepicker
                  :language="ko"
                  :format="customFormatter"
                  :disabled-dates="disabledEDate"
                  v-model="endDate"
                  @selected="selectedEndDate(0)"
                  @closed="closeDate('end')"
                ></vuejs-datepicker>
              </span>
            </div>
          </div>
          <div class="select_box id">
            <label for="subsSttusCd" class="label">상태</label>
            <select name="subsSttusCd" id="subsSttusCd" v-model="grid.params.subsSttusCd" @keyup.enter="search">
              <option value="" selected>전체</option>
              <option v-for="(option, i) in subsSttusCdList" v-bind:value="option.code" v-bind:key="i">
                {{ option.codeNm }}
              </option>
            </select>
          </div>
          <div class="select_box">
            <label for="custTyCd" class="label">구분</label>
            <select name="custTyCd" id="custTyCd" v-model="grid.params.custTyCd" @keyup.enter="search">
              <option value="" selected>전체</option>
              <option v-for="(option, i) in custTyCdList" v-bind:value="option.code" v-bind:key="i">
                {{ option.codeNm }}
              </option>
            </select>
          </div>
          <div class="input_box">
            <label for="right" class="label">유치자 마당ID</label>
            <input
              class="search-box"
              type="text"
              id=""
              placeholder="검색어 입력"
              v-model.trim="grid.params.loginId"
              maxlength="50"
            />
          </div>
          <div class="input_box">
            <label for="right" class="label">유치업체</label>
            <input
              class="search-box"
              type="text"
              id=""
              placeholder="검색어 입력"
              v-model.trim="grid.params.norgNm"
              maxlength="50"
            />
          </div>
        </div>
        <div class="group">
          <div class="select_box">
            <label for="right" class="label">상세검색</label>
            <select name="searchType" id="searchType" v-model="searchType" @keyup.enter="search">
              <option value="01">고객사명</option>
              <option value="02">이름</option>
              <option value="03">사업자등록번호</option>
            </select>
          </div>
          <div class="input_box">
            <input
              class="search-box"
              type="text"
              id="search"
              placeholder="검색어 입력"
              v-model.trim="grid.params.searchText"
              maxlength="100"
            />
          </div>
          <button type="button" class="button grey" @click="search">조회</button>
        </div>
      </div>
      <div class="info">
        <div class="count">
          총 <span>{{ totalItems.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',') }}</span
          >건
          <div class="select_box NumberSe">
            <select name="" id="" v-model="perPageCnt" @change="changePerPage()">
              <option v-for="option in options" v-bind:value="option.value" v-bind:key="option.value">
                {{ option.text }}
              </option>
            </select>
          </div>
        </div>
        <div class="button_group">
          <button type="button" class="button blue download" @click="excelDown()">엑셀 다운로드</button>
        </div>
      </div>

      <div class="table">
        <custom-grid
          ref="table"
          :totalItems="'totalItems'"
          :url="grid.url"
          :pagePerRows="grid.pagePerRows"
          :initialRequest="grid.initialRequest"
          :pagination="grid.pagination"
          :isCheckbox="grid.isCheckbox"
          :columns="grid.columns"
          :noDataStr="grid.noDataStr"
          :addCls="grid.addCls"
          :header="grid.headder"
        ></custom-grid>
      </div>

      <common-modal ref="commonModal"></common-modal>
    </div>
  </div>
</template>

<script>
import commonModal from '@/components/modal/commonModal';
import customGrid from '@/components/CustomGrid';
import moment from 'moment';
import api from '@/service/api.js';
import channelMgtApi from '../service/channelMgtApi.js';
import xlsx from '@/common/excel';

class CustomATagRenderer {
  constructor(props) {
    this.props = props;
    const el = document.createElement('a');
    el.href = 'javascript:void(0);';
    el.className = 'btn_text';
    el.innerText = String(props.colValue);
    this.el = el;
  }

  getElement() {
    return this.el;
  }

  addEvent(selEl) {
    selEl.addEventListener('click', () => {
      const { callback } = this.props['cgrido' + this.props.colName].options;
      callback(this.props);
    });
  }
}

export default {
  name: 'channelList',
  data() {
    const vm = this;
    return {
      ko: vdp_translation_ko.js,
      periodDay: 7,
      sDateDiv: 'day',
      startDate: new Date(),
      endDate: new Date(),

      row: {},
      pageType: 'CHANNEL',
      subsSttusCdList: [],
      custTyCdList: [],
      openPicker: false,
      // 테이블 리스트 데이터
      perPageCnt: 50,
      options: [
        { text: '20', value: 20 },
        { text: '50', value: 50 },
        { text: '100', value: 100 },
      ],
      searchType: '01',
      totalItems: 0,
      grid: {
        url: '/api/v1/bo/attractMgt/channelList',
        pagePerRows: 20,
        pagination: true,
        isCheckbox: false, // true:첫번째 컬럼 앞에 체크박스 생성 / false:체크박스 제거
        initialRequest: false,
        addCls: 'box_OFvis',

        columns: [
          { name: 'no', header: 'No', align: 'center', width: '6%' },
          { name: 'subsDt', header: '가입일', align: 'center', width: '11%' },
          { name: 'norgNm', header: '유치업체', align: 'center', width: '10%' },
          { name: 'userSeq', header: '사용자일련번호', align: 'center', width: '10%', hidden: true },
          { name: 'loginId', header: '마당ID(이름)', align: 'center', width: '10%' },
          {
            name: 'custNm',
            header: '고객사명',
            align: 'center',
            width: '10%',
            renderer: {
              type: CustomATagRenderer,
              options: {
                callback: this.channelDetail,
              },
            },
            formatter: (props) => {
              let result = vm.fromHtmlEntities(props.custNm);
              //.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
              return result;
            },
          },
          { name: 'bizrno', header: '사업자번호', align: 'center', width: '12%' },
          { name: 'userNm', header: '이름', align: 'center', width: '10%' },
          { name: 'subsSttusCd', header: '상태', align: 'center', width: '10%', hidden: true },
          { name: 'subsSttusNm', header: '상태', align: 'center', width: '10%' },
          { name: 'custTyCd', header: '구분', align: 'center', width: '10%', hidden: true },
          { name: 'custTyNm', header: '구분', align: 'center', width: '10%' },
          {
            name: 'sndCnt',
            header: '전체발송건수',
            align: 'center',
            width: '11%',
            formatter: (props) => {
              let result = props.sndCnt ? props.sndCnt.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',') : '0';
              return result;
            },
          },
        ],
        noDataStr: '검색 결과가 없습니다.',
        params: {
          searchType: '01',
          searchType1: '',
          searchText: '',
          subsStDt: '',
          subsEdDt: '',
          subsSttusCd: '',
          subsSttusNm: '',
          loginId: '',
          norgNm: '',
          sndCnt: '',
          custTyCd: '',
          custTyNm: '',
        },
        excelHeader: [],
      },
    };
  },
  components: {
    customGrid: customGrid,
    commonModal,
    vuejsDatepicker,
  },
  created() {
    this.setCodeData();
    this.getExcelHeader();
    this.setPeriodDay(0);

    // this.grid.params.subsSttusCd = '';
    // this.grid.params.searchType = '01';
    // this.$refs.searchType_.
  },
  destroyed() {
    this.grid.params.subsSttusCd = '';
  },
  mounted() {
    let page = 1;
    // 페이지 정보 및 검색 조건
    const getCondition = this.$store.getters['searchcondition/getSearchCondition'];

    // store에 저장된 페이지 정보 및 검색 조건을 불러오기
    let isKeep = false;
    if (getCondition) {
      this.grid.pagePerRows = getCondition.perPage;
      this.grid.params = getCondition.params;
      page = getCondition.page;
      isKeep = true;
    }
    this.search(isKeep);
  },
  methods: {
    search: function (isKeep) {
      this.grid.params.subsStDt = this.startDate;
      this.grid.params.subsEdDt = this.endDate;
      this.grid.params.searchType = this.searchType;
      this.$refs.table.search(this.grid.params, isKeep);
      this.sendStoreData();
    },
    changePerPage: function () {
      // 페이지당 조회할 개수
      this.grid.pagePerRows = this.perPageCnt;
      this.search(true);
    },
    sendStoreData: function () {
      const getP = this.$refs.table.getPagination();
      this.$store.commit('searchcondition/updateSearchCondition', {
        page: getP._currentPage,
        perPage: this.perPageCnt,
        params: this.grid.params,
      });

      const getCondition = this.$store.getters['searchcondition/getSearchCondition'];
    },
    async getExcelDataDown() {
      try {
        let response;
        const params = {
          subsStDt: this.grid.params.subsStDt,
          subsEdDt: this.grid.params.subsEdDt,
          searchType1: this.grid.params.searchType,
          searchType2: this.grid.params.searchType1,
          searchText1: this.grid.params.searchText,
          loginId: this.grid.params.loginId,
          norgNm: this.grid.params.norgNm,
        };

        response = await channelMgtApi.channelListExcel(params);

        const result = response.data;
        // entity code 변환
        result.data.list = result.data.list.map((item) => {
          return {
            ...item,
            custNm: this.fromHtmlEntities(item.custNm)
          }
        });
        if (result != null && result.retCode == '0000') {
          return result.data;
        } else {
          return false;
        }
      } catch (err) {
        return false;
      }
    }, // end of getExcelDataDown
    async excelDown() {
      if (this.$refs.table.getData().length <= 0) {
        this.row.title = '유치채널현황';
        this.row.msg1 = '조회된 데이터가 없습니다.';
        this.$refs.commonModal.alertModalOpen(this.row);
        return false;
      }

      let today = moment().format('YYYYMMDDHHmmss');
      const saveFileName = `유치채널현황_${today}.xls`;

      const data = await this.getExcelDataDown();
      let options = {
        header: this.excelHeader,
        dataOrder: 'header',
      };
      xlsx.export(data.list, saveFileName, options).then(() => {});
    },
    getExcelHeader() {
      // 헤더를 mockup으로 관리한다.
      channelMgtApi.getExcelHeader(this.pageType).then((res) => {
        this.excelHeader = res;
      });
    },
    channelDetail(props) {
      this.row.userId = props.loginId;
      this.row.userSeq = props.userSeq;
      this.$router.push({ name: 'channelDetail', params: this.row });
    },
    setCodeData() {
      // 상태 옵션 셋팅.
      api.commCode({ grpCd: 'SUBS_STTUS_CD' }).then((response) => {
        // grid.params.subsSttusCd
        this.subsSttusCdList = response.data.data.list;
        this.grid.params.subsSttusCd = '';
      });

      api.commCode({ grpCd: 'CUST_KD_CD' }).then((response) => {
        this.custTyCdList = response.data.data.list;
        this.grid.params.custTyCd = '';
      });
    },
    setPeriodDay(day) {
      this.periodDay = day;
      this.endDate = new Date();
      // this.startDate = moment(this.endDate)
      //     .subtract(day, 'day')
      //     .toDate();
      this.initSetStartDate();
      this.closeDate('start');
      this.closeDate('end');
    },

    selectedStartDate(day) {
      if (day != undefined && day != null) {
        this.periodDay = day;
      }
      if (this.startDate > this.endDate) {
        this.startDate = this.endDate;
      }
    },
    selectedEndDate(day) {
      if (day != undefined && day != null) {
        this.periodDay = day;
      }
    },
    closeDate(type) {
      if (type != undefined && type != null) {
        if (type == 'start') {
          this.disabledSDate = { from: this.endDate };
          this.disabledEDate = { to: this.startDate, from: this.endDate };
        } else if (type == 'end') {
          this.disabledSDate = { from: this.endDate };
          this.disabledEDate = { to: this.startDate, from: new Date() };
        }
      }
    },
    customFormatter: function (date) {
      if (this.sDateDiv == 'month') {
        return moment(date).format('YYYY-MM');
      } else if (this.sDateDiv == 'year') {
        return moment(date).format('YYYY');
      } else {
        return moment(date).format('YYYY-MM-DD');
      }
    },
    initSetStartDate() {
      let setYear = Number(moment(new Date()).format('YYYY'));
      let initStartDate = new Date(setYear, 0, 1);
      this.startDate = initStartDate;
    },
    fromHtmlEntities(str) {
      return (str + '').replace(/&#\d+;/gm, function (s) {
        return String.fromCharCode(s.match(/\d+/gm)[0]);
      });
    },
  },
  beforeRouteLeave(to, from, next) {
    const getP = this.$refs.table.getPagination();
    this.$store.commit('searchcondition/updateSearchCondition', {
      page: getP._currentPage,
      perPage: this.perPageCnt,
      params: this.grid.params,
    });
    // 라우트 하기전 실행
    next();
  },
};
</script>
